;(setq lasm_ops *t*)
; ᮡ⢥, ᠬ  ᥬ

(setq lasm-operators '(
  (cpl  lasm-do-op0 $2F)
  (ccf  lasm-do-op0 $3F)
  (di   lasm-do-op0 $F3)
  (daa  lasm-do-op0 $27)
  (exx  lasm-do-op0 $D9)
  (ei   lasm-do-op0 $FB)
  (halt lasm-do-op0 $76)
  (nop  lasm-do-op0 $00)
  (rla  lasm-do-op0 $17)
  (rlca lasm-do-op0 $07)
  (rra  lasm-do-op0 $1F)
  (rrca lasm-do-op0 $0F)
  (scf  lasm-do-op0 $37)

  (exaf lasm-do-op0 $08)  ; ex af,af'
  (rst0 lasm-do-op0 $C7)  ; rst #0
  (rst1 lasm-do-op0 $CF)  ; rst #8
  (rst2 lasm-do-op0 $D7)  ; rst #10
  (rst3 lasm-do-op0 $DF)  ; rst #18
  (rst4 lasm-do-op0 $E7)  ; rst #20
  (rst5 lasm-do-op0 $EF)  ; rst #28
  (rst6 lasm-do-op0 $F7)  ; rst #30
  (rst7 lasm-do-op0 $FF)  ; rst #38

  (xslt lasm-do-op0 $ED $FB)  ; SLT trap
  (xlsp lasm-do-op0 $ED $06)  ; lisp trap
  (cpd  lasm-do-op0 $ED $A9)
  (cpdr lasm-do-op0 $ED $B9)
  (cpi  lasm-do-op0 $ED $A1)
  (cpir lasm-do-op0 $ED $B1)
  (ind  lasm-do-op0 $ED $AA)
  (indr lasm-do-op0 $ED $BA)
  (ini  lasm-do-op0 $ED $A2)
  (inir lasm-do-op0 $ED $B2)
  (ldir lasm-do-op0 $ED $B0)
  (lddr lasm-do-op0 $ED $B8)
  (ldi  lasm-do-op0 $ED $A0)
  (ldd  lasm-do-op0 $ED $A8)
  (neg  lasm-do-op0 $ED $44)
  (otdr lasm-do-op0 $ED $BB)
  (otir lasm-do-op0 $ED $B3)
  (outd lasm-do-op0 $ED $AB)
  (outi lasm-do-op0 $ED $A3)
  (rld  lasm-do-op0 $ED $6F)
  (rrd  lasm-do-op0 $ED $67)
  (reti lasm-do-op0 $ED $4D)
  (retn lasm-do-op0 $ED $45)
  (inf  lasm-do-op0 $ED $70)  ; in  f,(c)  in (c)
  (outf lasm-do-op0 $ED $71)  ; out (c),0

  (add  lasm-do-add  $80)
  (and  lasm-do-alu  $A0)
  (adc  lasm-do-alu2 $88)
  (bit  lasm-do-bit  $40)
  (call lasm-do-call $CD)
  (cp   lasm-do-alu  $B8)
  (dec  lasm-do-alu3 $05)
  (djnz lasm-do-djnz $10)
  (ex   lasm-do-ex   $00)
  (inc  lasm-do-alu3 $04)
  (in   lasm-do-in   $DB)
  (im   lasm-do-im   $46)
  (jr   lasm-do-jr   $18)
  (jp   lasm-do-jp   $C3)
  (ld   lasm-do-ld   $40)
  (or   lasm-do-alu  $B0)
  (out  lasm-do-out  $D3)
  (pop  lasm-do-ppop $C1)
  (push lasm-do-ppop $C5)
  (ret  lasm-do-ret  $C9)
  (rl   lasm-do-sft  $10)
  (rlc  lasm-do-sft  $00)
  (rr   lasm-do-sft  $18)
  (rrc  lasm-do-sft  $08)
  (res  lasm-do-ress $80)
  (rst  lasm-do-rst  $C7)
  (sub  lasm-do-alu  $90)
  (sbc  lasm-do-alu2 $98)
  (set  lasm-do-ress $C0)
  (sla  lasm-do-sft  $20)
  (sra  lasm-do-sft  $28)
  (srl  lasm-do-sft  $38)
  (sli  lasm-do-sft  $30)
  (sll  lasm-do-sft  $30)  ; my syntax %-)
  (xor  lasm-do-alu  $A8)

  ;(if    lasm-do-if    0)
  ;(else  lasm-do-else  0)
  ;(elsif lasm-do-elsif 0)
  ;(endif lasm-do-endif 0)
  ;(disp  lasm-do-disp  0)
  ;(ent   lasm-do-ent   0)
  (equ   lasm-do-equ   0)
  (defb  lasm-do-defb  0)
  (db    lasm-do-defb  0)
  (defw  lasm-do-defw  0)
  (dw    lasm-do-defw  0)
  ;(defm  lasm-do-defm  0)
  ;(defr  lasm-do-defr  0)
  ;(defs  lasm-do-defs  0)
  ;(ds    lasm-do-defs  0)

  (org   lasm-do-org   0)
  (macro lasm-do-macro 0)
  (extern lasm-do-extern 0)
  (include lasm-do-include 0)
  (incbin lasm-do-incbin 0)
))

(setq lasm-user-operators *nil*)
  ;  ,   ।饥,   짮⥫᪨ ஢
  ; (ᮢ  祣)


; ᯨ᮪ ⨯:
;  '( item0 ... itemN)
;  item: ( 楤-ࠡ⪨ )
; 頥 item  *nil*
(defun asm-find-in-oplist (ops name | n)
  ;(setq name (atom2str name))
  (for (setq n ops)
       (land n  (<> name (caar n)))
       (setq n (cdr n))
       ()
  )
  (if n (setq n (car n)))
  n
)

(defun lasm-add-operator (name handler | n)
  (setq n (asm-find-in-oplist lasm-operators name))
  (if (null? n)  (setq n (asm-find-in-oplist lasm-user-operators name)))
  (if n (bad-syntax (|| "duplicate user command: " (upper-case name))))
  (setq lasm-user-operators  (cons (list name handler 0) lasm-user-operators))
)

(defun asm-do-cmd (| item elst)
; 襬   ᪥, ᯠ館  
  (if lasm-cmd (begin
    ;(println "asm-do-cmd")
    (setq lasm-ext-label *nil*)
    (setq item (asm-find-in-oplist lasm-operators lasm-cmd))
    (if (null? item)  (setq item (asm-find-in-oplist lasm-user-operators lasm-cmd)))
    (if (null? item) (bad-syntax (|| "unknown command: " (upper-case lasm-cmd))))
    ;(println "command: " (car item))
    ;   ந ᠪ  eval()
    (setq elst
      (list (cadr item) (list 'quote (car item)) (list 'quote (cddr item)))
    )
    ;(lprintln "asm-cmd:" elst)
    (eval elst)
  ))
)

(defun lasm-memhl-to-r8 ()
; ८ࠧ㥬 (hl)  memref  reg8
  (if (land (= arg-type argf-mem) (= arg-val argm-hl))
    (setq arg-type argf-reg8  arg-val argr8-mem)
  )
)

(defun lasm-next-arg ()
; ⨬ ᫥騩 㬥
; 騯뢠   lasm-argv
  (asm-arg-interpret (car lasm-argv))
  (setq lasm-argv (cdr lasm-argv))
  arg-type
)

(defun lasm-expect-cond ()
; ᫥騩 㬥   ᫮
; 騯뢠   lasm-argv
  (asm-arg-interpret-cond (car lasm-argv))
  (if (<> arg-type argf-cond)  (bad-syntax (|| "condition expected in " (upper-case cmd))))
  (setq lasm-argv (cdr lasm-argv))
  arg-val
)

(defun lasm-expect-num (| n)
; ᫥騩 㬥   ᫮     ᪮
; 騯뢠   lasm-argv
  (setq n (trim-left (car lasm-argv)))
  (if (= (nth n 1) 40)  (bad-syntax (|| "number expected in " (upper-case cmd))))
  (asm-arg-interpret n)
  (if (<> arg-type argf-number)  (bad-syntax (|| "number expected in " (upper-case cmd))))
  (setq lasm-argv (cdr lasm-argv))
  arg-val
)

(defun lasm-expect-memref (| n)
; ᫥騩 㬥   ᫮    ᪮
; 騯뢠   lasm-argv
  (setq n (trim-left (car lasm-argv)))
  (if (<> (nth n 1) 40)  (bad-syntax (|| "memory reference expected in " (upper-case cmd))))
  (asm-arg-interpret n)
  (if (<> arg-type argf-number)  (bad-syntax (|| "memory reference expected in " (upper-case cmd))))
  (setq lasm-argv (cdr lasm-argv))
  arg-val
)

(defun lasm-e-addr (n)
;    ᫮
  (if asmexpr-addr (lasm-emit-addr n)
   (lasm-emit-word n)
  )
)

(defun lasm-e-byte-a (n)
;  -  ᫮
  (if asmexpr-addr (lasm-emit-addr-byte n)
   (lasm-emit-byte n)
  )
)

(defun lasm-e-reladdr (n)
; relative jump to n (JR, DJNZ)
  (if lasm-ext-label (bad-syntax (|| "external label in JR/DJNZ: " lasm-ext-label))
   (lasm-emit-byte (- n (incr asm-pc)))
  )
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; -  -⮢ 㬥஢ 
(defun lasm-do-op0 (cmd codez)
; cmd:  
; codez: ᯨ᮪ 誮
  (if (= lasm-argc 0) (lasm-emit-list codez)
    (bad-syntax (|| "extra args in " (upper-case cmd)))
  )
)

(defun lasm-do-ret (cmd codez)
; RET
  (switch lasm-argc
    0 (lasm-emit-list codez)  ; just RET
    1 (lasm-emit-byte (+ $C0 (* (lasm-expect-cond) 8)))
    (bad-syntax "invalid RET syntax")
  )
)

(defun lasm-do-call (cmd codez)
; CALL
  (switch lasm-argc
    1 (begin
        (lasm-emit-list codez)
        (lasm-e-addr (lasm-expect-num))
      )
    2 (begin
        (lasm-emit-byte (+ $C4 (* (lasm-expect-cond) 8)))
        (lasm-e-addr (lasm-expect-num))
      )
    (bad-syntax "invalid CALL syntax")
  )
)

(defun lasm-do-jp (cmd codez)
; JP
  (switch lasm-argc
    1 (switch (car lasm-argv)
        "(hl)" (lasm-emit-byte $E9)
        "(ix)" (lasm-emit-list '($DD $E9))
        "(iy)" (lasm-emit-list '($FD $E9))
       ;  룠
       (begin (lasm-emit-list codez) (lasm-e-addr (lasm-expect-num)))
      )
    2 (begin
        (lasm-emit-byte (+ $C2 (* (lasm-expect-cond) 8)))
        (lasm-e-addr (lasm-expect-num))
      )
    (bad-syntax "invalid JP syntax")
  )
)

(defun lasm-do-djnz (cmd codez)
; DJNZ
  (switch lasm-argc
    1 (begin (lasm-emit-list codez) (lasm-e-reladdr (lasm-expect-num)))
    (bad-syntax "invalid DJNZ syntax")
  )
)

(defun lasm-do-jr (cmd codez)
; JR
  (switch lasm-argc
    1 (begin (lasm-emit-byte $18) (lasm-e-reladdr (lasm-expect-num)))
    2 (begin
        (switch (lasm-expect-cond)
          argc-nz (lasm-emit-byte $20)
          argc-z  (lasm-emit-byte $28)
          argc-nc (lasm-emit-byte $30)
          argc-c  (lasm-emit-byte $38)
         (bad-syntax "invalid JR syntax")
        )
        (lasm-e-reladdr (lasm-expect-num))
      )
    (bad-syntax "invalid JR syntax")
  )
)

(defun lasm-do-ppop (cmd codez)
; PUSH/POP
  (if (zero? lasm-argc)
    (bad-syntax (|| "invalid " (upper-case cmd) " syntax"))
  )

  (for () lasm-argv (setq lasm-argv (cdr lasm-argv))
    (switch (car lasm-argv)
      "bc" (lasm-emit-byte (| (car codez) $00))
      "de" (lasm-emit-byte (| (car codez) $10))
      "hl" (lasm-emit-byte (| (car codez) $20))
      "af" (lasm-emit-byte (| (car codez) $30))
      "ix" (begin (lasm-emit-byte $DD) (lasm-emit-byte (| (car codez) $20)))
      "iy" (begin (lasm-emit-byte $FD) (lasm-emit-byte (| (car codez) $20)))
     (bad-syntax (|| "invalid " (upper-case cmd) " register: " (car lasm-argv)))
    )
  )
)

(defun lasm-do-im (cmd codez)
  (lasm-emit-byte $ED)
  (switch lasm-argc
    1 (switch (lasm-expect-num)
        0 (lasm-emit-byte $46)
        1 (lasm-emit-byte $56)
        2 (lasm-emit-byte $5E)
       (bad-syntax "invalid IM mode")
      )
    (bad-syntax "invalid IM syntax")
  )
)

(defun lasm-do-ex (cmd codez | r0 r1)
  (if (<> lasm-argc 2)  (bad-syntax "invalid EX syntax"))

  (setq r0 (car lasm-argv)  lasm-argv (cdr lasm-argv)  r1 (car lasm-argv))
  (switch r0
    "af" (begin
           (if (land (<> r1 "af'") (<> r1 "af")) (bad-syntax "invalid EX syntax"))
           (lasm-emit-byte $08)
         )
    "af'" (begin
           (if (land (<> r1 "af'") (<> r1 "af"))  (bad-syntax "invalid EX syntax"))
           (lasm-emit-byte $08)
         )
    "de" (switch r1
           "hl" (lasm-emit-byte $EB)
          (bad-syntax "invalid EX syntax")
         )
    "hl" (switch r1
           "de" (lasm-emit-byte $EB)
           "(sp)" (lasm-emit-byte $E3)
          (bad-syntax "invalid EX syntax")
         )
    "ix" (switch r1
           "(sp)" (lasm-emit-list '($DD $E3))
          (bad-syntax "invalid EX syntax")
         )
    "iy" (switch r1
           "(sp)" (lasm-emit-list '($FD $E3))
          (bad-syntax "invalid EX syntax")
         )
    "(sp)" (switch r1
           "hl" (lasm-emit-byte $E3)
           "ix" (lasm-emit-list '($DD $E3))
           "iy" (lasm-emit-list '($FD $E3))
          (bad-syntax "invalid EX syntax")
         )
  )
)

(defun lasm-do-sft (cmd codez)
;RL,RLC,RR,RRC,SLA,SRA,SRL,SLI,SLL
  (if (not (within lasm-argc 1 2))
    (bad-syntax (|| "invalid " (upper-case cmd) " syntax")))

  (lasm-next-arg) (lasm-memhl-to-r8)
  (if (land (<> arg-type argf-memidx) (<> lasm-argc 1))
    (bad-syntax (|| "invalid " (upper-case cmd) " syntax")))

  (if (<> arg-idxreg 0) (lasm-emit-byte arg-idxreg))
  (lasm-emit-byte $CB)
  (if (= arg-type argf-memidx)
    (begin
      (lasm-emit-byte arg-val)  ; disp
      (if (= lasm-argc 1)  (setq arg-type argf-reg8  arg-val argr8-mem)
       (lasm-next-arg)
      )
    )
  )

  (switch arg-type
    argf-reg8 (lasm-emit-byte (+ (car codez) arg-val))
   (bad-syntax (|| "invalid " (upper-case cmd) " syntax"))
  )
)

(defun lasm-do-ress (cmd codez | bn)
;RES,SET
  (if (not (within lasm-argc 2 3))
    (bad-syntax (|| "invalid " (upper-case cmd) " syntax")))

  (setq bn (lasm-expect-num))
  (if (lor (< bn 0) (> bn 7))
    (bad-syntax (|| "invalid " (upper-case cmd) " syntax")))
  (setq bn (+ (car codez) (* bn 8)))  ; so bn is the opcode (w/o reginfo)

  (lasm-next-arg) (lasm-memhl-to-r8)
  (if (land (<> arg-type argf-memidx) (<> lasm-argc 2))
    (bad-syntax (|| "invalid " (upper-case cmd) " syntax")))

  (if (<> arg-idxreg 0) (lasm-emit-byte arg-idxreg))
  (lasm-emit-byte $CB)
  (if (= arg-type argf-memidx)
    (begin
      (lasm-emit-byte arg-val)  ; disp
      (if (= lasm-argc 2)  (setq arg-type argf-reg8  arg-val argr8-mem)
       (lasm-next-arg)
      )
    )
  )

  (switch arg-type
    argf-reg8 (lasm-emit-byte (+ bn arg-val))
   (bad-syntax (|| "invalid " (upper-case cmd) " syntax"))
  )
)

(defun lasm-do-bit (cmd codez | bn)
;BIT
  (if (<> lasm-argc 2)  (bad-syntax "invalid BIT syntax"))

  (setq bn (lasm-expect-num))
  (if (lor (< bn 0) (> bn 7))
    (bad-syntax (|| "invalid " (upper-case cmd) " syntax")))
  (setq bn (+ (car codez) (* bn 8)))  ; so bn is the opcode (w/o reginfo)

  (lasm-next-arg) (lasm-memhl-to-r8)

  (if (<> arg-idxreg 0) (lasm-emit-byte arg-idxreg))
  (lasm-emit-byte $CB)
  (if (= arg-type argf-memidx)
    (begin
      (lasm-emit-byte arg-val)  ; disp
      (setq arg-type argf-reg8  arg-val argr8-mem)
    )
  )

  (switch arg-type
    argf-reg8 (lasm-emit-byte (+ bn arg-val))
   (bad-syntax "invalid BIT syntax")
  )
)

(defun lasm-do-alu (cmd codez | idx)
;AND,CP,OR,SUB,XOR, ADC A,SBC A,ADD A
  (setq idx *f*)
  (switch lasm-argc
    1 *t*
    2 (begin
        (if (<> (car lasm-argv) "a")
          (bad-syntax (|| "invalid " (upper-case cmd) " syntax")))
        (setq lasm-argv (cdr lasm-argv))
      )
   (bad-syntax (|| "invalid " (upper-case cmd) " syntax"))
  )

  (lasm-next-arg) (lasm-memhl-to-r8)
  (if
    (= arg-type argf-memidx)
      (begin
        (lasm-emit-byte arg-idxreg)
        (setq arg-idxreg arg-val  arg-type argf-reg8  arg-val argr8-mem  idx *t*)
      )
  )

  (if
    (= arg-type argf-reg8)
      (begin
        (lasm-emit-byte (+ (car codez) arg-val))
        (if idx (lasm-emit-byte arg-idxreg))
      )
    (land (not arg-memref) (= arg-type argf-number))
      (begin
        (switch cmd
          "add" (begin (lasm-emit-byte $C6) (lasm-e-byte-a arg-val))
          "sub" (begin (lasm-emit-byte $D6) (lasm-e-byte-a arg-val))
          "and" (begin (lasm-emit-byte $E6) (lasm-e-byte-a arg-val))
          "or" (begin (lasm-emit-byte $F6) (lasm-e-byte-a arg-val))
          "adc" (begin (lasm-emit-byte $CE) (lasm-e-byte-a arg-val))
          "sbc" (begin (lasm-emit-byte $DE) (lasm-e-byte-a arg-val))
          "xor" (begin (lasm-emit-byte $EE) (lasm-e-byte-a arg-val))
          "cp" (begin (lasm-emit-byte $FE) (lasm-e-byte-a arg-val))
         (bad-syntax (|| "invalid " (upper-case cmd) " syntax"))
        )
      )
   (bad-syntax (|| "invalid " (upper-case cmd) " syntax"))
  )
)

(defun lasm-do-alu2 (cmd codez)
; ADC,SBC
  (switch lasm-argc
    1 (lasm-do-alu cmd codez)
    2 (if (= (car lasm-argv) "a") (lasm-do-alu cmd codez)
        (= (car lasm-argv) "hl")
          (begin
            (setq lasm-argv (car (cdr lasm-argv))
                  lasm-argc (if (= cmd "adc") $4A $42)
            )
            (lasm-emit-byte $ED)
            (switch lasm-argv
              "bc" (lasm-emit-byte lasm-argc)
              "de" (lasm-emit-byte (+ lasm-argc $10))
              "hl" (lasm-emit-byte (+ lasm-argc $20))
              "sp" (lasm-emit-byte (+ lasm-argc $30))
             (bad-syntax (|| "invalid " (upper-case cmd) " syntax"))
            )
          )
       (bad-syntax (|| "invalid " (upper-case cmd) " syntax"))
      )
   (bad-syntax (|| "invalid " (upper-case cmd) " syntax"))
  )
)

(defun lasm-do-add (cmd codez | dst)
; ADD
  (switch lasm-argc
    1 (lasm-do-alu cmd codez)
    2 (if (= (car lasm-argv) "a") (lasm-do-alu cmd codez)
       (begin
         (setq dst (car lasm-argv))
         (switch dst
           "hl" *t*
           "ix" (lasm-emit-byte $DD)
           "iy" (lasm-emit-byte $FD)
          (bad-syntax "invalid ADD syntax")
         )

         (setq lasm-argv (car (cdr lasm-argv)))

         (switch lasm-argv
           "hl" (setq dst (= dst "hl"))
           "ix" (setq dst (= dst "ix")  lasm-argv "hl")
           "iy" (setq dst (= dst "iy")  lasm-argv "hl")
         )

         (switch lasm-argv
           "bc" (lasm-emit-byte $09)
           "de" (lasm-emit-byte $19)
           "sp" (lasm-emit-byte $39)
           "hl"
             (if dst (lasm-emit-byte $29)  (bad-syntax "invalid ADD syntax"))
          (bad-syntax "invalid ADD syntax")
         )
       )
      )
   (bad-syntax "invalid ADD syntax")
  )
)

(defun lasm-do-alu3 (cmd codez | idx)
; DEC,INC
  (setq idx *f*)
  (switch lasm-argc
    1 (switch (car lasm-argv)
        "bc" (lasm-emit-byte (if (= (car codez) 4) $03 $0B))
        "de" (lasm-emit-byte (if (= (car codez) 4) $13 $1B))
        "hl" (lasm-emit-byte (if (= (car codez) 4) $23 $2B))
        "sp" (lasm-emit-byte (if (= (car codez) 4) $33 $3B))
        "ix" (begin (lasm-emit-byte $DD) (lasm-emit-byte (if (= (car codez) 4) $23 $2B)))
        "iy" (begin (lasm-emit-byte $FD) (lasm-emit-byte (if (= (car codez) 4) $23 $2B)))
       (begin
         (lasm-next-arg) (lasm-memhl-to-r8)
         (if (= arg-type argf-memidx)
           (begin
             (lasm-emit-byte arg-idxreg)
             (setq arg-idxreg arg-val  arg-type argf-reg8  arg-val argr8-mem  idx *t*)
           )
         )

         (if (<> arg-type argf-reg8)
           (bad-syntax (|| "invalid " (upper-case cmd) " syntax")))

         (lasm-emit-byte (+ (car codez) (* arg-val 8)))

         (if idx (lasm-emit-byte arg-idxreg))
       )
      )
   (bad-syntax (|| "invalid " (upper-case cmd) " syntax"))
  )
)

(defun lasm-do-rst (cmd codez | rn)
; RST
  (switch lasm-argc
    1 (begin
        (switch (lasm-expect-num)
          0 (lasm-emit-byte $C7)
          1 (lasm-emit-byte $CF)  $08 (lasm-emit-byte $CF)
          2 (lasm-emit-byte $D7)  $10 (lasm-emit-byte $D7)
          3 (lasm-emit-byte $DF)  $18 (lasm-emit-byte $DF)
          4 (lasm-emit-byte $E7)  $20 (lasm-emit-byte $E7)
          5 (lasm-emit-byte $EF)  $28 (lasm-emit-byte $EF)
          6 (lasm-emit-byte $F7)  $30 (lasm-emit-byte $F7)
          7 (lasm-emit-byte $FF)  $38 (lasm-emit-byte $FF)
         (bad-syntax "invalid RST syntax")
        )
      )
   (bad-syntax "invalid RST syntax")
  )
)

(defun lasm-do-in (cmd codez | is-2-memc)
; IN
  (defun is-2-memc ()
    (if (<> (cadr lasm-argv) "(c)")  (bad-syntax "invalid IN syntax"))
  )

  (switch lasm-argc
    1 (if (= (car lasm-argv) "(c)") (lasm-emit-list '($ED $70))
       (bad-syntax "invalid IN syntax")
      )
    2 (switch (car lasm-argv)
        "a"
          (switch (cadr lasm-argv)
            "(c)" (lasm-emit-list '($ED $78))
           (begin
             (setq lasm-argv (cadr lasm-argv))
             (if (land (> (length lasm-argv) 2)
                     (= (nth lasm-argv 1) 40)
                     (= (nth lasm-argv -1) 41)
                   )
               (begin
                 (lasm-emit-byte $DB)
                 (setq lasm-argc (eval (expr-prefix lasm-argv)))
                 (lasm-emit-byte lasm-argc)
                 ;(if (within lasm-argc 0 255) (lasm-emit-byte lasm-argc)
                 ; (bad-syntax "invalid IN syntax")
                 ;)
               )
              (bad-syntax "invalid IN syntax")
             )
           )
          )
        "b" (begin (is-2-memc) (lasm-emit-list '($ED $40)))
        "c" (begin (is-2-memc) (lasm-emit-list '($ED $48)))
        "d" (begin (is-2-memc) (lasm-emit-list '($ED $50)))
        "e" (begin (is-2-memc) (lasm-emit-list '($ED $58)))
        "h" (begin (is-2-memc) (lasm-emit-list '($ED $60)))
        "l" (begin (is-2-memc) (lasm-emit-list '($ED $68)))
       (bad-syntax "invalid IN syntax")
      )
   (bad-syntax "invalid IN syntax")
  )
)

(defun lasm-do-out (cmd codez | is-1-memc)
; OUT
  (defun is-1-memc ()
    (if (<> (car lasm-argv) "(c)")  (bad-syntax "invalid OUT syntax"))
  )

  (switch lasm-argc
    1 (if (= (car lasm-argv) "(c)") (lasm-emit-list '($ED $71))
       (bad-syntax "invalid OUT syntax")
      )
    2 (switch (cadr lasm-argv)
        "a"
          (switch (car lasm-argv)
            "(c)" (lasm-emit-list '($ED $79))
           (begin
             (setq lasm-argv (car lasm-argv))
             (if (land (> (length lasm-argv) 2)
                     (= (nth lasm-argv 1) 40)
                     (= (nth lasm-argv -1) 41)
                   )
               (begin
                 (lasm-emit-byte $D3)
                 (setq lasm-argc (eval (expr-prefix lasm-argv)))
                 (lasm-emit-byte lasm-argc)
                 ;(if (within lasm-argc 0 255) (lasm-emit-byte lasm-argc)
                 ; (bad-syntax "invalid OUT syntax")
                 ;)
               )
              (bad-syntax "invalid OUT syntax")
             )
           )
          )
        "0" (begin (is-1-memc) (lasm-emit-list '($ED $71)))
        "b" (begin (is-1-memc) (lasm-emit-list '($ED $41)))
        "c" (begin (is-1-memc) (lasm-emit-list '($ED $49)))
        "d" (begin (is-1-memc) (lasm-emit-list '($ED $51)))
        "e" (begin (is-1-memc) (lasm-emit-list '($ED $59)))
        "h" (begin (is-1-memc) (lasm-emit-list '($ED $61)))
        "l" (begin (is-1-memc) (lasm-emit-list '($ED $69)))
       (bad-syntax "invalid OUT syntax")
      )
   (bad-syntax "invalid OUT syntax")
  )
)

(defun lasm-do-ld (cmd codez |
; LD
    done idx
    is-0-a is-1-a ok
    do-1reg8 do-1reg16 do-1mem do-1memidx do-1mref do-2mref
    arg0 arg1
  )

  (defun ok () (setq done *t*))

  (defun is-0-a ()
    (if (<> arg0 "a")  (bad-syntax "invalid LD syntax"))
  )

  (defun is-1-a ()
    (if (<> arg1 "a")  (bad-syntax "invalid LD syntax"))
  )

  ;;;;;;;;;;
  (defun do-2mref ()
    (ok) (switch arg0
      "bc" (begin (lasm-emit-list '($ED $4B)) (lasm-e-addr arg-val))
      "de" (begin (lasm-emit-list '($ED $5B)) (lasm-e-addr arg-val))
      "hl" (begin (lasm-emit-byte $2A) (lasm-e-addr arg-val))
      "sp" (begin (lasm-emit-list '($ED $7B)) (lasm-e-addr arg-val))
      "ix" (begin (lasm-emit-list '($DD $2A)) (lasm-e-addr arg-val))
      "iy" (begin (lasm-emit-list '($FD $2A)) (lasm-e-addr arg-val))
      "a" (begin (lasm-emit-byte $3A) (lasm-e-addr arg-val))
      (setq done *f*)
    )
  )

  (defun do-1mref ()
    (ok) (switch arg1
      "bc" (begin (lasm-emit-list '($ED $43)) (lasm-e-addr arg-val))
      "de" (begin (lasm-emit-list '($ED $53)) (lasm-e-addr arg-val))
      "hl" (begin (lasm-emit-byte $22) (lasm-e-addr arg-val))
      "sp" (begin (lasm-emit-list '($ED $73)) (lasm-e-addr arg-val))
      "ix" (begin (lasm-emit-list '($DD $22)) (lasm-e-addr arg-val))
      "iy" (begin (lasm-emit-list '($FD $22)) (lasm-e-addr arg-val))
      "a" (begin (lasm-emit-byte $32) (lasm-e-addr arg-val))
      (setq done *f*)
    )
  )

  (defun do-1mem ()
    (switch arg-val
      argm-bc (begin (is-1-a) (lasm-emit-byte $02) (ok))
      argm-de (begin (is-1-a) (lasm-emit-byte $12) (ok))
      argm-hl
        (switch arg1
          "b" (begin (lasm-emit-byte $70) (ok))
          "c" (begin (lasm-emit-byte $71) (ok))
          "d" (begin (lasm-emit-byte $72) (ok))
          "e" (begin (lasm-emit-byte $73) (ok))
          "h" (begin (lasm-emit-byte $74) (ok))
          "l" (begin (lasm-emit-byte $75) (ok))
          "a" (begin (lasm-emit-byte $77) (ok))
         (begin ; imm
           (lasm-expect-num)
           (lasm-emit-byte $36) (lasm-e-byte-a arg-val)
           (ok)
         )
        )
    )
  )

  (defun do-1memidx (| imm)
    (setq imm *f*)
    (lasm-emit-byte arg-idxreg)
    (switch arg1
      "b" (begin (lasm-emit-byte $70) (ok))
      "c" (begin (lasm-emit-byte $71) (ok))
      "d" (begin (lasm-emit-byte $72) (ok))
      "e" (begin (lasm-emit-byte $73) (ok))
      "h" (begin (lasm-emit-byte $74) (ok))
      "l" (begin (lasm-emit-byte $75) (ok))
      "a" (begin (lasm-emit-byte $77) (ok))
     (begin ; imm
       (setq imm arg-val)
       (lasm-expect-num)
       (lasm-emit-byte $36)
       (lasm-emit-byte imm)
       (lasm-e-byte-a arg-val)
       (setq imm *t*)
       (ok)
     )
    )
    (if (land done (not imm)) (lasm-emit-byte arg-val))  ; offset (or imm)
  )

  (defun do-1reg16 (| dst)
    (if (= arg0 "sp")
      (switch arg1
        "hl" (begin (lasm-emit-byte $F9) (ok))
        "ix" (begin (lasm-emit-list '($DD $F9)) (ok))
        "iy" (begin (lasm-emit-list '($FD $F9)) (ok))
      )
    )
    (if (not done) (begin
      (setq dst arg-val)
      (lasm-expect-num)
      (switch dst
        argr16-bc (begin (lasm-emit-byte $01) (ok))
        argr16-de (begin (lasm-emit-byte $11) (ok))
        argr16-hl (begin (lasm-emit-byte $21) (ok))
        argr16-sp (begin (lasm-emit-byte $31) (ok))
        argr16-ix (begin (lasm-emit-list '($DD $21)) (ok))
        argr16-iy (begin (lasm-emit-list '($FD $21)) (ok))
      )
      (if done (lasm-e-addr arg-val))
    ))
  )

  (defun do-1reg8 (| dst)
    (setq cde (+ $40 (* arg-val 8))) ; base code
    (asm-arg-interpret arg1)
    (switch arg-type
      argf-reg8 (begin (lasm-emit-byte (+ cde arg-val)) (ok))
      argf-mem
        (switch arg-val
          argm-bc (begin (is-0-a) (lasm-emit-byte $0A) (ok))
          argm-de (begin (is-0-a) (lasm-emit-byte $1A) (ok))
          argm-hl
            (switch arg0
              "b" (begin (lasm-emit-byte $46) (ok))
              "c" (begin (lasm-emit-byte $4E) (ok))
              "d" (begin (lasm-emit-byte $56) (ok))
              "e" (begin (lasm-emit-byte $5E) (ok))
              "h" (begin (lasm-emit-byte $66) (ok))
              "l" (begin (lasm-emit-byte $6E) (ok))
              "a" (begin (lasm-emit-byte $7E) (ok))
            )
        )
      argf-memidx (begin
        (lasm-emit-byte arg-idxreg)
        (switch arg0
          "b" (begin (lasm-emit-byte $46) (ok))
          "c" (begin (lasm-emit-byte $4E) (ok))
          "d" (begin (lasm-emit-byte $56) (ok))
          "e" (begin (lasm-emit-byte $5E) (ok))
          "h" (begin (lasm-emit-byte $66) (ok))
          "l" (begin (lasm-emit-byte $6E) (ok))
          "a" (begin (lasm-emit-byte $7E) (ok))
        )
        (if done (lasm-emit-byte arg-val))
        )
      argf-number ; imm
        (if (not arg-memref) (begin
          (switch arg0
            "b" (begin (lasm-emit-byte $06) (ok))
            "c" (begin (lasm-emit-byte $0E) (ok))
            "d" (begin (lasm-emit-byte $16) (ok))
            "e" (begin (lasm-emit-byte $1E) (ok))
            "h" (begin (lasm-emit-byte $26) (ok))
            "l" (begin (lasm-emit-byte $2E) (ok))
            "a" (begin (lasm-emit-byte $3E) (ok))
          )
          (if done (lasm-e-byte-a arg-val))
        ))
    )
  )

  ;;;;;;;;;;
  (if (<> lasm-argc 2) (bad-syntax "invalid LD syntax"))
  (setq idx *f*  done *f*  arg0 (car lasm-argv)  arg1 (cadr lasm-argv))

  (asm-arg-interpret arg1)
  (if
    (land arg-memref (= arg-type argf-number))
      (begin
        ;(println "2memref!!")
        (do-2mref)
        ;(lprintln done)
        (if (not done) (bad-syntax "invalid LD syntax"))
      )
  )

  (if (not done) (begin
    (ok) (switch arg0
      "i" (begin (is-1-a) (lasm-emit-list '($ED $47)))
      "r" (begin (is-1-a) (lasm-emit-list '($ED $4F)))
      (setq done *f*)
    )
  ))
  (if (not done) (begin
    (ok) (switch arg1
      "i" (begin (is-0-a) (lasm-emit-list '($ED $57)))
      "r" (begin (is-0-a) (lasm-emit-list '($ED $5F)))
      (setq done *f*)
    )
  ))

  (if (not done) (begin
    (setq lasm-ext-label *nil*)
    (lasm-next-arg) ;(asm-arg-interpret arg0)
    (switch arg-type
      argf-reg8   (do-1reg8)
      argf-reg16  (do-1reg16)
      argf-mem    (do-1mem)
      argf-memidx (do-1memidx)
      argf-number (if arg-memref (do-1mref))
    )
  ))

  (if (not done) (bad-syntax "invalid LD syntax"))
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun lasm-do-org (cmd codez)
; ORG
  (switch lasm-argc
    1 (begin
        (if (find-symbol "dsp")
          ; inside DSP?
          (if (= (car lasm-argv) "pc")  (setq asm-pc (z80reg "pc"))
           (setq asm-pc (lasm-expect-num))
          )
         (setq asm-pc (lasm-expect-num))
        )
        (lasm-new-org asm-pc)
      )
    (bad-syntax "invalid ORG syntax")
  )
)

(defun lasm-do-equ ()
; EQU
  (switch lasm-argc
    1 (begin
        (if (not lasm-label) (bad-syntax "invalid EQU syntax: label expected"))
        (lasm-expect-num)
        (lasm-add-label lasm-label arg-val asmexpr-addr)
      )
    (bad-syntax "invalid EQU syntax")
  )
)

(defun lasm-do-extern (cmd codez)
  (for (if (zero? lasm-argc) (bad-syntax "invalid EXTERN syntax"))
       lasm-argv  (setq lasm-argv (cdr lasm-argv))
    (begin
      (lasm-add-label (car lasm-argv) 0 *t* *t*)
    )
  )
)

(defun lasm-do-defb (cmd codez)
  ;(println "DEFB")
  (for (if (zero? lasm-argc) (bad-syntax "invalid DEFB syntax"))
       lasm-argv  (setq lasm-argv (cdr lasm-argv))
    (begin
      (setq lasm-ext-label *nil*)
      (asm-arg-interpret (car lasm-argv))
      (switch arg-type
        argf-number (lasm-e-byte-a arg-val)
        argf-str
          (for (setq lasm-argc 1) (<= lasm-argc (length arg-val))
               (setq lasm-argc (incr lasm-argc))
            (lasm-emit-byte (nth arg-val lasm-argc))
          )
      )
    )
  )
)

(defun lasm-do-defw (cmd codez)
  (for (if (zero? lasm-argc) (bad-syntax "invalid DEFW syntax"))
       lasm-argv  (setq lasm-argv (cdr lasm-argv))
    (begin
      (setq lasm-ext-label *nil*)
      (asm-arg-interpret (car lasm-argv))
      (switch arg-type
        argf-number (lasm-e-addr arg-val)
        argf-str
          (for (setq lasm-argc 1) (<= lasm-argc (length arg-val))
               (setq lasm-argc (incr lasm-argc))
            (lasm-emit-byte (nth arg-val lasm-argc))
          )
      )
    )
  )
)

(defun lasm-do-incbin (cmd codez)
  (switch lasm-argc
    1 (begin (locals fh)
        (setq fh (fopen (car lasm-argv) "r-"))
        (if (not fh) (bad-syntax (|| "invalid file in INCBIN: " (car lasm-argv))))
        (while (< (fcurpos fh) (fsize fh))
          (lasm-emit-byte (fread-byte fh))
        )
        (fclose fh)
      )
    (bad-syntax "invalid INCBIN syntax")
  )
)
