(defun read-pok (fname | get-tok fh s t lst x)

  (defun get-tok ( | n t)
    (setq s (trim s)  n (str-pos " " s))
    ;(lprint n)
    (if (zero? n) (setq n (incr (length s))))
    (setq t (trim (str-mid s 1 n))  s (str-mid s (incr n)))
    ;(lprintln "token" t)
    t
  )

  (setq inf-list *nil*)
  (if (number? (setq fh (fopen fname "r-"))) (begin
    (for (setq s (freadln fh)) s (setq s (freadln fh))
      (if (<> (ord s) 89)
        (catch ; for toint
          (setq lst (cons (trim (str-mid s 2)) *nil*)  t "")
          (until (eq t "Z")
            (setq s (freadln fh))
            (if (null? s) (break))
            (setq t (get-tok)) (get-tok)
            (setq lst (cons (toint (get-tok)) lst))
            (setq x (toint (get-tok)))
            (if (= x 256) (setq x 255))
            (setq lst (cons x lst))
            (setq lst (cons (toint (get-tok)) lst))
          )
          (setq inf-list (cons (reverse lst) inf-list))
        )
      )
    ) (fclose fh))
   (println "no file")
  )
  (setq inf-list (reverse inf-list))
)

(defun load-pok ( | pn)
  (setq pn (change-ext latest-snap-file ".pok"))
  ;(lprintln "[" (extract-path pn) "]")
  ;(lprintln "[" (extract-name pn) "]")
  ;(lprintln "[" (extract-ext pn) "]")
  (if (not (file-exist pn))
    (setq pn (|| (extract-path pn) "pokes\\" (extract-name pn)))
  )
  ;(lprintln "<" pn ">")
  (read-pok pn)
)

(con-execute "alias pok ':(load-pok)'")
